
/*  
    Programm to read the PC Funkuhr 
    Copyright (C) 1997,1998 Joachim Koenig 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <asm/system.h>
#include <asm/io.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <sched.h>
#include <sys/resource.h>

#define FAKTOR 238

int ports[] = {0x278,0x378,0x3bc,0};
int port;

char buffer1[18],buffer2[18];
struct sched_param sched;

void waiter (int);
int read_time(char *);

int make_time(char *buffer)
{
struct tm t;
time_t oldtime,newtime;
    if (buffer[0] != 9)
      return 1;
    t.tm_mday = buffer[11] * 10 + buffer[10];
    t.tm_mon = buffer[13] * 10 + buffer[12] - 1;
    t.tm_year = buffer[15] * 10 + buffer[14];
    if (t.tm_year < 80) t.tm_year += 100;
    t.tm_hour = buffer[7] * 10 + buffer[6];
    t.tm_min = buffer[5] * 10 + buffer[4];
    t.tm_sec = buffer[3] * 10 + buffer[2];
    if (t.tm_mday == 0 || t.tm_mon == -1)
      return 1; 
    t.tm_isdst = -1;
    newtime = mktime (&t);
    time(&oldtime);
    stime(&newtime);
    if (buffer[8] & 1)
          printf("MEST ");
    if (buffer[8] & 2)
          printf("MET ");
    if (buffer[8] & 4)
          printf("Low Batt ");
    printf("%s",asctime(localtime(&newtime)));
    printf("Correction for %d seconds\n",(int)(newtime - oldtime));
    if (buffer[1] & 1)
          printf("last sync not OK\n");
    return 0;

}

int try_port() {
int l=0;
    while (l++ < 10) {          /* several tries */
      if (read_time(buffer1)==0 && buffer1[0] == 9)     /* 1. read */
        if (read_time(buffer2)==0 && buffer2[0] == 9)   /* 2. read */
          if (memcmp(&buffer1[3],&buffer2[3],13) == 0)  /* security check */
            if (make_time(buffer2) == 0)                /* time set */
              return 0;
    }
    return 1;
}

int main(int argc, char *argv[])
{
int i=0;
    if (iopl(3)) 
        abort();
   
    if (argc == 2) {
      port = strtol(argv[1],(char**)NULL,16);
      try_port();
    } else { 
      while ((port = ports[i++]) && try_port());
	  if (port)
        printf("Found at port 0x%02x\n",port);
    }
    return 0;
}

unsigned short get_tick() {
unsigned char i,j;
unsigned short k;
    cli();
    outb(0,0x43);
    i = inb(0x40);
    j = inb(0x40);
    sti();
    k = (j << 8) + i;
    return (~k);
}

void waiter( int delay) {     /* wait for 100us */
unsigned int di,si;
int k;
unsigned long j;
    if (delay == 0)
        return;
    k = 0;
    di = get_tick();
    j = (long)FAKTOR * (long)delay + (long)di;
    while (1) {
        si = get_tick();
        if ((long)si > j) {
            return;
        }
        if (si<di) {
            if (j<0x10000) {
                return;
            }
            j -= 0x10000;
        }
        di = si;
    }
}


int read_time(char *p)
{
int test;
int si,di,end,i;
int index;

    memset(p,0,18);
    si = 0;
    end = 100;

    sched.sched_priority = 1;
        sched_setscheduler(0,SCHED_FIFO,&sched); /* make it real time */
    for (i=0;i<8;i++) {
        outb(i & 7,port);
        outb(i & 1 ? 4 : 6,port+2);
        waiter(30);                     /* wait 3ms */
    }
    outb(0,port);
    outb(6,port+2);
    waiter(30);
    outb(4,port+2);

while (si < 69) {  /* Read 69 Bit of data stream */
    di = 0;
    index = si / 4;
    *(p+index) <<= 1;
    test = (si % 2) == 0 ? 0x10 : 0;
    while (((inb(port+1) & 0x10) == test) && (di++ < end)) { /* clock change ?*/
        waiter(1);
    }
    if (di >= end) {  /* timeout ? */
        sched.sched_priority = 0;
            sched_setscheduler(0,SCHED_OTHER,&sched);
        return 1;
    }
    waiter(5);     /* wait until middle of bit */
    if (inb(port+1) & 0x20)
        *(p+index) |= 1;
    si++;
    end = 40;
}
sched.sched_priority = 0;
sched_setscheduler(0,SCHED_OTHER,&sched);
return 0;
}

